import com.sun.javafx.geom.Vec2d;
import processing.core.PApplet;
import processing.core.PGraphics;

import java.awt.*;
import java.util.Random;

/**
 * Created by Henrich Lauko on 15.10.2015.
 */
public class Fluffy {

    private float x;
    private float y;
    private Vec2d direction;
    private Color color;
    private int alpha;
    private Boolean death = false;

    private int width = 3;
    private int particle_width = 15;

    public Fluffy(int x, int y, Vec2d direction, int alpha, PApplet applet) {
        this.x = x;
        this.y = y;
        this.direction = direction;
        this.alpha = alpha;
        this.color = new Color((int)(Math.random() * 255), (int)(Math.random() * 255), (int)(Math.random() * 255));
    }

    public void draw(float i, PApplet applet) {

        x = x + i * (float)direction.x;
        y = y + i * (float)direction.y;

        alpha--;

        if (alpha == 0 || x < 0 || y < 0) {
            death = true;
        }

        for (int k = 0; k < 3; k++) {
            float px = applet.random(-width, width);
            float py = applet.random(-width, width);

            //white mode
            /*applet.stroke(255, 255, 255, alpha);
            applet.fill(255, 255, 255, alpha);*/

            //color mode
            applet.stroke(color.getRed(), color.getGreen(), color.getBlue(), alpha);
            applet.fill(color.getRed(), color.getGreen(), color.getBlue(), alpha);

            applet.ellipse(x + px, y + py, particle_width, particle_width);
        }
    }

    public float getX() {
        return x;
    }

    public float getY() {
        return y;
    }

    public int getAlpha() {
        return alpha;
    }

    public void setAlpha(int alpha) {
        this.alpha = alpha;
    }

    public Boolean getDeath() {
        return death;
    }

    public void setDeath(Boolean death) {
        this.death = death;
    }

    public Vec2d getDirection() {
        return direction;
    }

    public Color getColor() {
        return color;
    }

    public void setX(int x) {
        this.x = x;
    }

    public void setY(int y) {
        this.y = y;
    }

    public void setDirection(Vec2d direction) {
        this.direction = direction;
    }

    public void setColor(Color color) {
        this.color = color;
    }
}
