import com.sun.javafx.geom.Vec2d;
import processing.core.*;
import com.sun.awt.AWTUtilities;

import java.util.ArrayList;
import java.util.Iterator;

public class Processing extends PApplet {

    private ArrayList<Fluffy> fluffies;

    private Vec2d prev;

    private Boolean generate = false;

    public void setup() {

        fluffies = new ArrayList<Fluffy>();
        prev = new Vec2d(0,0);

        size(displayWidth, displayHeight);
        frame.removeNotify();
        frame.setUndecorated(true);
        AWTUtilities.setWindowOpacity(frame,0.5f);
        frame.addNotify();
    }


    public void draw() {
        clear();

        if (generate) {
            createFluffy();
        }

        for (Iterator<Fluffy> iterator = fluffies.iterator(); iterator.hasNext();){
            Fluffy fluffy = iterator.next();
            if (fluffy.getDeath()) {
                iterator.remove();
            }else {
                fluffy.draw(0.02f, this);
            }
        }
    }

    public void createFluffy() {
        int tolerance = 1900;
        if ( Math.abs(prev.x - mouseX) < tolerance && Math.abs(prev.y - mouseY) < tolerance) {
            Vec2d dir = new Vec2d(prev.x - mouseX, prev.y - mouseY);
            fluffies.add(new Fluffy(mouseX, mouseY, dir, 255, this));
        }
        prev.x = mouseX;
        prev.y = mouseY;
    }

    public void mousePressed() {
        generate = true;
    }

    public void mouseReleased() {
        generate = false;
    }

    static public void main(String args[]) {
        PApplet.main(new String[] { "Processing" });
    }
}